package com.hai.dao;

import com.hai.entity.OutRechargeOrderRecord;
import com.hai.entity.OutRechargeOrderRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface OutRechargeOrderRecordMapper extends OutRechargeOrderRecordMapperExt {
    @SelectProvider(type=OutRechargeOrderRecordSqlProvider.class, method="countByExample")
    long countByExample(OutRechargeOrderRecordExample example);

    @DeleteProvider(type=OutRechargeOrderRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(OutRechargeOrderRecordExample example);

    @Delete({
        "delete from out_recharge_order_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into out_recharge_order_record (recharge_order_id, recharge_order_no, ",
        "create_time, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{rechargeOrderId,jdbcType=BIGINT}, #{rechargeOrderNo,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(OutRechargeOrderRecord record);

    @InsertProvider(type=OutRechargeOrderRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(OutRechargeOrderRecord record);

    @SelectProvider(type=OutRechargeOrderRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="recharge_order_id", property="rechargeOrderId", jdbcType=JdbcType.BIGINT),
        @Result(column="recharge_order_no", property="rechargeOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<OutRechargeOrderRecord> selectByExample(OutRechargeOrderRecordExample example);

    @Select({
        "select",
        "id, recharge_order_id, recharge_order_no, create_time, `status`, ext_1, ext_2, ",
        "ext_3",
        "from out_recharge_order_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="recharge_order_id", property="rechargeOrderId", jdbcType=JdbcType.BIGINT),
        @Result(column="recharge_order_no", property="rechargeOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    OutRechargeOrderRecord selectByPrimaryKey(Long id);

    @UpdateProvider(type=OutRechargeOrderRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") OutRechargeOrderRecord record, @Param("example") OutRechargeOrderRecordExample example);

    @UpdateProvider(type=OutRechargeOrderRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") OutRechargeOrderRecord record, @Param("example") OutRechargeOrderRecordExample example);

    @UpdateProvider(type=OutRechargeOrderRecordSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(OutRechargeOrderRecord record);

    @Update({
        "update out_recharge_order_record",
        "set recharge_order_id = #{rechargeOrderId,jdbcType=BIGINT},",
          "recharge_order_no = #{rechargeOrderNo,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(OutRechargeOrderRecord record);
}